from Globals import HTMLFile      # fakes a method from a DTML file
from Globals import MessageDialog # provid
from Globals import Persistent    # makes an object stick in the ZODB

from OFS.DTMLMethod import DTMLMethod

#from ZODB.Transaction import Transaction, get_transaction

import OFS.SimpleItem
import OFS.Folder
import Acquisition
import AccessControl.Role

import re
import string
from xmlrpclib import True, False, Server

defaultCss = """
"""

defaultCustomPrefs = """
"""

defaultJavaScript = """
"""

defaultJoinNowMembersBox = """
"""

defaultNavigation = """
"""

defaultNewsDayTemplate = """
"""

defaultSignOutMembersBox = """
"""

defaultSiteStructure = """
"""

defaultTemplate = """
<dtml-var standard_html_header>
\t<table cellspacing="0" cellpadding="0" border="0">
\t\t<tr>
\t\t\t<td colspan="4">
\t\t\t\t<font size="+2"><b><dtml-var "zopeFishHomeTag(zopeFishTitle())"></b></font>
\t\t\t\t</td>
\t\t\t<td align="right">
\t\t\t\t<i>
\t\t\t\t<dtml-if "self().users.loggedIn(REQUEST)">
\t\t\t\t\thello, <dtml-var "self().users.getLoggedInUsername(REQUEST)">
\t\t\t\t<dtml-else>
\t\t\t\t\thello!
\t\t\t\t\t</dtml-if>
\t\t\t\t</i>
\t\t\t\t</td>
\t\t\t</tr>
\t\t<tr height="20"><td colspan="3">&nbsp;</td></tr>
\t\t<tr>
\t\t\t<td valign="top" align="right" bgcolor="gray" width="75">
\t\t\t\t<a href="<dtml-var locationNoHost>/discuss">discuss</a>
\t\t\t\t<p><br><br>
\t\t\t\t<dtml-if "self().users.loggedIn(REQUEST)">
\t\t\t\t\t<a href="<dtml-var locationNoHost>/users/logoff?redirect=<dtml-var locationNoHost>">log off</a>
\t\t\t\t<dtml-else>
\t\t\t\t\t<a href="<dtml-var locationNoHost>/users">login</a>
\t\t\t\t\t</dtml-if>
\t\t\t\t</td>
\t\t\t<td width="10" bgcolor="gray">&nbsp;</td>
\t\t\t<td width="10">&nbsp;</td>
\t\t\t<td valign="top" width="450">
\t\t\t\t<h2><dtml-var title></h2>
\t\t\t\t<dtml-var body>
\t\t\t\t<p>
\t\t\t\t</td>
\t\t\t</tr>
\t\t<tr>
\t\t\t<td colspan="5">
\t\t\t\t<hr size="1" noshade>
\t\t\t\t<dtml-var creditsTag>
\t\t\t\t<dtml-if "self().users.isManager(REQUEST)">
\t\t\t\t\t | <dtml-var prefsTag>
\t\t\t\t\t</dtml-if>
\t\t\t\t</td>
\t\t\t</tr>
\t\t</table>
\t<dtml-var standard_html_footer>
"""

oldDefaultTemplate = """
<dtml-var standard_html_header>
<table width="100%" border="0" cellpadding="5" cellspacing="0">
\t<tr bgcolor="darkgray">
\t\t<td>
\t\t\t<dtml-var zopeFishTitle>
\t\t\t</td>
\t\t<td align="right">
\t\t\t<dtml-var zopeFishHomeTag>
\t\t\t</td>
\t\t</tr>
\t</table>
<table width="100%" border="0" cellpadding="5" cellspacing="0">
\t<tr>
\t\t<td width="35">
\t\t\t&nbsp;<br>
\t\t\t</td>
\t\t<td>
\t\t\t&nbsp;<br>
\t\t\t<dtml-var body>
\t\t\t</td>
\t\t</tr>
\t</table>
<p>
<dtml-var standard_html_footer>"""

class DocumentControl(
    OFS.Folder.Folder,
    Persistent,
    Acquisition.Implicit,
    AccessControl.Role.RoleManager
    ):
    """documentcontrol"""

    default = ""
    current = ""
    ownerName = ""
    ownerPassword = ""
    owned = 0

    meta_type = "Pike Compatible XML-RPC Document Control Responder"

    manage_main = HTMLFile('leafnodesDisplay', globals()) # Management Interface

    def __init__(self, defaultString, container, id, parent):
        """__init__"""
        self.default = defaultString
        self.current = defaultString
        self.container = container
        self.ownerName = ""
        self.ownerPassword = ""
        self.owned = 0
        self.parent = parent
        self.id = id
        self.title = id

    def manage_afterAdd(self, item, container): pass
    def manage_afterClone(self, item): pass
    def manage_beforeDelete(self, item, container): pass

    def objectItems(self, type=None):
        """   """
        return [("checkIn", self.checkIn),
                ("get", self.get),
                ("restoreDefault", self.restoreDefault),
                ("set", self.set)]

    def objectValues(self, type=None):
        """   """
        return [self.checkIn, self.get, self.restoreDefault, self.set]

    def objectIds(self, type=None):
        """   """
        return [self.checkIn.id, self.get.id, self.restoreDefault.id, self.set.id]

    def checkIn(self, username, password, siteName):
        """checkIn"""
        print "manila." + self.id + ".checkIn:"
        print "\tusername    :", username
        print "\tpassword    :", password
        print "\tsitename    :", siteName
        print "---------------------"
        return True

    def get(self, username, password, siteName):
        """get"""
        print "manila." + self.id + ".get:"
        print "\tusername    :", username
        print "\tpassword    :", password
        print "\tsitename    :", siteName
        print "---------------------"
        return self.current

    def restoreDefault(self, username, password, sitename):
        """restoreDefault"""
        print "manila." + self.id + ".restoreDefault:"
        print "\tusername    :", username
        print "\tpassword    :", password
        print "\tsitename    :", sitename
        print "---------------------"
        self.current = self.default

    def set(self, username, password, sitename, s, windowInfo):
        """set"""
        print "manila." + self.id + ".set:"
        print "\tusername    :", username
        print "\tpassword    :", password
        print "\tsitename    :", sitename
        print "\ts           :", s
        print "\twindowInfo  :", windowInfo
        print "---------------------"
        self.current = s

class TemplateControl(DocumentControl):
    """   """
    
    def restoreDefault(self, username, password, sitename):
        """restoreDefault"""
        DocumentControl.restoreDefault(self, username, password, sitename)
        self.parent.template.manage_edit(self.current, "template")
        return True
        
    def set(self, username, password, sitename, s, windowInfo):
        """set"""
        DocumentControl.set(self, username, password, sitename, s, windowInfo)
        self.parent.template.manage_edit(self.current, "template")
        return True

class Messages(
    OFS.Folder.Folder,
    Persistent,
    Acquisition.Implicit,
    AccessControl.Role.RoleManager
    ):
    """messages"""

    meta_type = "Pike Compatible XML-RPC Message Responder"

    manage_main = HTMLFile('leafnodesDisplay', globals()) # Management Interface
    manage_workspace = manage_main

    def __init__(self, id, parent):
        """   """
        self.parent = parent
        self.id = id
        self.title = id

    def manage_afterAdd(self, item, container): pass
    def manage_afterClone(self, item): pass
    def manage_beforeDelete(self, item, container): pass

    def objectItems(self, type=None):
        """   """
        return [("addToStoriesList", self.addToStoriesList),
                ("checkIn", self.checkIn),
                ("isStory", self.isStory),
                ("removeFromStoriesList", self.removeFromStoriesList),
                ("create", self.create),
                ("set", self.set)]

    def objectValues(self, type=None):
        """   """
        return [self.addToStoriesList,
                self.checkIn,
                self.isStory,
                self.removeFromStoriesList,
                self.create,
                self.set]

    def objectIds(self, type=None):
        """   """
        return [self.addToStoriesList.id,
                self.checkIn.id,
                self.isStory.id,
                self.removeFromStoriesList.id,
                self.create.id,
                self.set.id]

    def addToStoriesList(self, username, password, sitename, msgNum):
        """addToStoriesList"""
        print "manila." + self.id + ".addToStoriesList:"
        print "\tusername:", username
        print "\tpassword:", password
        print "\tsitename:", sitename
        print "\tmsgNum  :", msgNum
        print "-----------------"
        return True

    def checkIn(self, username, password, siteName, msgNum):
        """checkIn"""
        print "manila." + self.id + ".checkIn:"
        print "\tusername:", username
        print "\tpassword:", password
        print "\tsiteName:", siteName
        print "\tmsgNum  :", msgNum
        print "-----------------"
        return True

    def isStory(self, username, password, sitename, msgNum):
        """isStory"""
        print "manila." + self.id + ".isStory:"
        print "\tusername:", username
        print "\tpassword:", password
        print "\tsitename:", sitename
        print "\tmsgNum  :", msgNum
        print "-----------------"
        return False

    def removeFromStoriesList(self, username, password, siteName, msgNum):
        """removeFromStoriesList"""
        print "manila." + self.id + ".removeFromStoriesList:"
        print "\tusername:", username
        print "\tpassword:", password
        print "\tsitename:", siteName
        print "\tmsgNum  :", msgNum
        print "-----------------"
        return True

    def create(self, username, password, sitename, subject, body,
               bodyType, inResponseTo, windowInfo, rendererInfo):
        """create"""
        print "manila." + self.id + ".create:"
        print "\tusername    :", username
        print "\tpassword    :", password
        print "\tsitename    :", sitename
        print "\tsubject     :", subject
        print "\tbody        :", body
        print "\tbodyType    :", bodyType
        print "\tinResponseTo:", inResponseTo
        print "\twindowInfo  :", windowInfo
        print "\trendererInfo:", rendererInfo
        print "---------------------"
        headers = self.makeHeaders(subject, bodyType, inResponseTo, rendererInfo, windowInfo)
        msgnum = self.parent.discuss.addNextMessage(body, headers)
        storyInfo = self.parent.getStoryInfo(None, subject, body, msgnum, username)
        return storyInfo

    def set(self, username, password, sitename, msgnum, subject, body,
            bodyType, windowInfo, rendererInfo):
        """set"""
        print "manila." + self.id + ".set:"
        print "\tusername    :", username
        print "\tpassword    :", password
        print "\tsitename    :", sitename
        print "\tmsgnum      :", msgnum
        print "\tsubject     :", subject
        print "\tbody        :", body
        print "\tbodyType    :", bodyType
        print "\twindowInfo  :", windowInfo
        print "\trendererInfo:", rendererInfo
        print "---------------------"
        msg = self.parent.discuss.getMessage(msgnum)
        msg.setTitle(subject)
        headers = msg.headers
        self.parent.discuss.addMessage(msgnum, body, headers)
        storyInfo = self.parent.getStoryInfo(None, subject, body, msgnum, username)
        return storyInfo

    def makeHeaders(self, subject, bodyType, inResponseTo, rendererInfo, windowInfo):
        """makeHeaders"""
        headers = {}
        headers['subject'] = subject
        headers['bodyType'] = bodyType
        headers['inResponseTo'] = inResponseTo
        headers['rendererInfo'] = rendererInfo
        headers['windowInfo'] = windowInfo
        return headers

class PikeCompatibility(
    OFS.Folder.Folder,
    Persistent,
    Acquisition.Implicit,
    AccessControl.Role.RoleManager
    ):
    """The Pike Compatible XML-RPC interface"""

    meta_type = "Pike Compatible XML-RPC Interface"

    manage_main = HTMLFile('zopefishEdit', globals()) # Management Interface
    manage_workspace = manage_main

    def __init__(self, id, parent):
        self.parent = parent
        self.id = id
        self.title = "Pike Compatible XML-RPC Interface"
        self.css = DocumentControl(
            defaultCss,
            None,
            "css",
            self.parent)
        self.customPrefs = DocumentControl(
            defaultCustomPrefs,
            None,
            "customPrefs",
            self.parent)
        self.javaScript = DocumentControl(
            defaultJavaScript,
            None,
            "javaScript",
            self.parent)
        self.joinNowMembersBox = DocumentControl(
            defaultJoinNowMembersBox,
            None,
            "joinNowMembersBox",
            self.parent)
        self.message = Messages("message", self.parent)
        self.navigation = DocumentControl(
            defaultNavigation,
            None,
            "navigation",
            self.parent)
        self.newsDayTemplate = DocumentControl(
            defaultNewsDayTemplate,
            None,
            "newsDayTemplate",
            self.parent)
        self.signOutMembersBox = DocumentControl(
            defaultSignOutMembersBox,
            None,
            "signOutMembersBox",
            self.parent)
        self.siteStructure = DocumentControl(
            defaultSiteStructure,
            None,
            "siteStructure",
            self.parent)
        self.template = TemplateControl(
            defaultTemplate,
            self.parent.template,
            "template",
            self.parent)

    def manage_afterAdd(self, item, container): pass
    def manage_afterClone(self, item): pass
    def manage_beforeDelete(self, item, container): pass

    def objectItems(self, type=None):
        """   """
        return [(self.css.id, self.css),
                (self.customPrefs.id, self.customPrefs),
                (self.javaScript.id, self.javaScript),
                (self.joinNowMembersBox.id, self.joinNowMembersBox),
                (self.message.id, self.message),
                (self.navigation.id, self.navigation),
                (self.newsDayTemplate.id, self.newsDayTemplate),
                (self.signOutMembersBox.id, self.signOutMembersBox),
                (self.siteStructure.id, self.siteStructure),
                (self.template.id, self.template)]

    def objectValues(self, type=None):
        """   """
        return [self.css,
                self.customPrefs,
                self.javaScript,
                self.joinNowMembersBox,
                self.message,
                self.navigation,
                self.newsDayTemplate,
                self.signOutMembersBox,
                self.siteStructure,
                self.template]

    def objectIds(self, type=None):
        """   """
        return [self.css.id,
                self.customPrefs.id,
                self.javaScript.id,
                self.joinNowMembersBox.id,
                self.message.id,
                self.navigation.id,
                self.newsDayTemplate.id,
                self.signOutMembersBox.id,
                self.siteStructure.id,
                self.template.id]

