from Globals import HTMLFile      # fakes a method from a DTML file
from Globals import MessageDialog # provid
from Globals import Persistent    # makes an object stick in the ZODB

from OFS.DTMLMethod import DTMLMethod

#from ZODB.Transaction import Transaction, get_transaction

import OFS.SimpleItem
import OFS.Folder
import Acquisition
import AccessControl.Role

import re
import string
from xmlrpclib import True, False, Server

class ZopeFishMessage(
    OFS.SimpleItem.Item,
    Persistent,            # Make us persistent. Yaah! 
    Acquisition.Implicit,  # Uh, whatever. 
    AccessControl.Role.RoleManager # Security manager. 
    ):
    """ZopeFishMessage"""

    meta_type = "ZopeFish Message"
    msg = ""
    headers = {}

    body = HTMLFile('zopefishMessage', globals())

    def __init__(self, theMsg, theHeaders, key, parent):
        """__init__"""
        self.msg = theMsg
        self.headers = theHeaders
        if self.headers.has_key('subject'):
            self.title = self.headers['subject']
        else:
            self.title = key
        self.id = key
        self.key = key
        self.parent = parent

    def setTitle(self, title):
        """   """
        self.title = title
        self.headers['subject'] = title

    def readMessageTag(self, tag=None):
        """readMessageTag"""
        if tag is None:
            tag = self.id
        return "<a href=\"" + \
               self.parent.locationNoHost + \
               "/discuss/" + \
               self.id + \
               "\">" + \
               tag + \
               "</a>"

    def editInTextArea(self, REQUEST=None):
        """   """
        pass

    def editInTextAreaTag(self, tag):
        """editInTextAreaTag"""
        return "<a href=\"" + \
               self.parent.locationNoHost + \
               "/discuss/" + \
               self.id + \
               "/editInTextArea\">" + \
               tag + \
               "</a>"

    def editInPike(self, REQUEST=None):
        """   """
        storyInfo = self.parent.getStoryInfo(REQUEST, self.title, self.msg, self.id)
        siteInfo = self.parent.getSiteInfo(REQUEST)
        self.parent.getPikeServer(REQUEST).pike.editStory(siteInfo, storyInfo)
        if REQUEST is not None:
            return REQUEST.RESPONSE.redirect(self.parent.locationNoHost + "/discuss/" + self.id)
        else:
            return self.index_html(REQUEST)

    def editInPikeTag(self, tag):
        """editInPikeTag"""
        return "<a href=\"" + \
               self.parent.locationNoHost + \
               "/discuss/" + \
               self.id + \
               "/editInPike\">" + \
               tag + \
               "</a>"

class ZopeFishMessageCollection(
    OFS.Folder.Folder,
    Persistent,            # Make us persistent. Yaah! 
    Acquisition.Implicit,  # Uh, whatever. 
    AccessControl.Role.RoleManager # Security manager. 
    ):
    """discussion group"""

    meta_type = "ZopeFish Message Collection"
    currentNum = 0

    manage_main = HTMLFile("discussEdit", globals())
    manage_workspace = manage_main

    def __init__(self, id, parent):
        """__init__"""
        self.parent = parent
        self.currentNum = 0
        self.id = id
        self.title = "Message Collection"

    def _getNextMessageKey(self):
        nextNum = self.currentNum
        self.currentNum = self.currentNum + 1
        return "msg%06d" % nextNum

    def addNextMessage(self, msg, headers):
        """   """
        msgnum = self._getNextMessageKey()
        self.addMessage(
            msgnum,
            msg,
            headers)
        return msgnum

    def addNextMessageNoHeaders(self, msg):
        """   """
        return self.addNextMessage(msg, {})

    def addMessage(self, key, msg, headers):
        """   """
        msgs = self.__dict__
        msgs[key] = ZopeFishMessage(msg, headers, key, self.parent)
        self.__dict__ = msgs

    def addMessageNoHeader(self, key, msg):
        """   """
        self.addMessage(key, msg, {})

    def checkMessage(self, key):
        """   """
        if not self.__dict__.has_key(key):
            raise AttributeError

    body = HTMLFile("discussIndex", globals())

    def newMessageInPikeTag(self, tag):
        """newMessageTag"""
        return "<a href=\"" + \
               self.parent.locationNoHost + \
               "/discuss/newMessageInPike\">" + \
               tag + \
               "</a>"

    def newMessageInPike(self, REQUEST=None):
        """   """
        storyInfo = self.parent.getStoryInfo(REQUEST, "New Pike Message", "", "msg000000")
        siteInfo = self.parent.getSiteInfo(REQUEST)
        self.parent.getPikeServer(REQUEST).pike.newStory(siteInfo, storyInfo)

    def getMessage(self, msgnum, REQUEST=None):
        """   """
        self.checkMessage(msgnum)
        msg = self.__dict__[msgnum]
        if REQUEST is not None:
            return msg.index_html(REQUEST)
        else:
            return msg

    def manage_afterAdd(self, item, container): pass
    def manage_afterClone(self, item): pass
    def manage_beforeDelete(self, item, container): pass

    def objectItems(self, type=None):
        """objectItems"""
        list = []
        for k in self.__dict__.keys():
            if k[0:3] == "msg":
                list.append((k, self.__dict__[k]))
        return list

    def objectValues(self, type=None):
        """objectValues"""
        list = []
        for k in self.__dict__.keys():
            if k[0:3] == "msg":
                list.append(self.__dict__[k])
        return list

    def objectIds(self, type=None):
        """objectValues"""
        list = []
        for k in self.__dict__.keys():
            if k[0:3] == "msg":
                list.append(k)
        return list

class StoryReader:
    """StoryReader"""
    pass

