from Globals import HTMLFile      # fakes a method from a DTML file
from Globals import MessageDialog # provid
from Globals import Persistent    # makes an object stick in the ZODB

from OFS.DTMLMethod import DTMLMethod

#from ZODB.Transaction import Transaction, get_transaction

import OFS.SimpleItem
import OFS.Folder
import Acquisition
import AccessControl.Role

import re
import string
from xmlrpclib import True, False, Server

class ZopeFishPreferences(
    OFS.Folder.Folder,
    Persistent,            # Make us persistent. Yaah! 
    Acquisition.Implicit,  # Uh, whatever. 
    AccessControl.Role.RoleManager # Security manager. 
    ):
    """ZopeFishPreferences"""

    def __init__(self, id, parent):
        """__init__"""
        self.id = id
        self.title = "ZopeFish Global Preferences Page"
        self.parent = parent
        self.body = HTMLFile("prefs", globals())

    def getPikePort(self, REQUEST):
        """getPikePort"""
        return str(self.parent.users.getUser(REQUEST).pikePort)

    def setPikePort(self, port, REQUEST):
        """setPikePort"""
        try:
            self.parent.users.getUser(REQUEST).pikePort = int(port)
        finally:
            pass
        REQUEST.RESPONSE.redirect(self.parent.locationNoHost + "/prefs")

    def getPikeHost(self, REQUEST):
        """getPikeHost"""
        user = self.parent.users.getUser(REQUEST)
        if user.pikeHost is None:
            return ''
        else:
            return user.pikeHost

    def setPikeHost(self, host, SUBMIT, REQUEST):
        """setPikeHost"""
        user = self.parent.users.getUser(REQUEST)
        if SUBMIT == "Reset":
            user.pikeHost = None
        else:
            if host[0:7] != "http://":
                host = "http://" + host
            user.pikeHost = host
        RESPONSE.redirect(self.parent.locationNoHost + "/prefs")

